"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var TempFileHost = /** @class */ (function () {
    function TempFileHost(file) {
        var _this = this;
        this.file = file;
        this.fileExists = function (name) { return name == "main.ts"; };
        this.readFile = function (name) { return name == "main.ts" && _this.file || undefined; };
        this.readDirectory = function () { return []; };
    }
    TempFileHost.prototype.getScriptFileNames = function () {
        return ["main.ts"];
    };
    TempFileHost.prototype.getScriptVersion = function (fileName) {
        return "latest";
    };
    TempFileHost.prototype.getScriptSnapshot = function (fileName) {
        if (fileName == "main.ts")
            return ts.ScriptSnapshot.fromString(this.file);
        return undefined;
    };
    TempFileHost.prototype.getCurrentDirectory = function () {
        return process.cwd();
    };
    TempFileHost.prototype.getCompilationSettings = function () {
        return {};
    };
    TempFileHost.prototype.getDefaultLibFileName = function (options) {
        return ts.getDefaultLibFilePath(options);
    };
    return TempFileHost;
}());
exports.TempFileHost = TempFileHost;
;
function format(content) {
    var host = new TempFileHost(content);
    var language = ts.createLanguageService(host, ts.createDocumentRegistry());
    var option = {
        convertTabsToSpaces: true,
        insertSpaceAfterCommaDelimiter: true,
        insertSpaceAfterKeywordsInControlFlowStatements: true,
        insertSpaceBeforeAndAfterBinaryOperators: true,
        newLineCharacter: "\n",
        indentStyle: ts.IndentStyle.Smart,
        indentSize: 4,
        tabSize: 4
    };
    var finalText = content;
    var textChanges = language.getFormattingEditsForDocument("main.ts", option);
    for (var _i = 0, _a = textChanges.sort(function (a, b) { return b.span.start - a.span.start; }); _i < _a.length; _i++) {
        var textChange = _a[_i];
        textChange;
        var span = textChange.span;
        finalText = finalText.slice(0, span.start) + textChange.newText
            + finalText.slice(span.start + span.length);
    }
    return finalText;
}
exports.format = format;
//# sourceMappingURL=tsFormatter.js.map